Bug 208640 - possible recursive locking detected: (&(&ip->i_lock)->mr_lock){----}, at: [<e112617c>] xfs_ilock+0x63/0x68 [xfs]
possible recursive locking detected: (&(&ip->i_lock)->mr_lock){----}, at: [<...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: kernel (Show other bugs)
5
i686 Linux
medium Severity medium
: ---
: ---
Assigned To: Eric Sandeen
Brian Brock
:
Depends On:
Blocks: FCMETA_LOCKDEP
  Show dependency treegraph
 
Reported: 2006-09-29 16:34 EDT by Dawid Gajownik
Modified: 2007-11-30 17:11 EST (History)
2 users (show)

See Also:
Fixed In Version: 2.6.18-1.2200.fc5
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2006-10-22 07:24:59 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)

  None (edit)
Description Dawid Gajownik 2006-09-29 16:34:57 EDT
Description of problem:

I found this in /var/log/messages:

Sep 29 12:18:31 X kernel: 
Sep 29 12:18:31 X kernel: =============================================
Sep 29 12:18:31 X kernel: [ INFO: possible recursive locking detected ]
Sep 29 12:18:31 X kernel: 2.6.18-1.2189.fc5 #1
Sep 29 12:18:31 X kernel: ---------------------------------------------
Sep 29 12:18:31 X kernel: kswapd0/157 is trying to acquire lock:
Sep 29 12:18:31 X kernel:  (&(&ip->i_lock)->mr_lock){----}, at: [<e112617c>]
xfs_ilock+0x63/0x68 [xfs]
Sep 29 12:18:31 X kernel: 
Sep 29 12:18:31 X kernel: but task is already holding lock:
Sep 29 12:18:31 X kernel:  (&(&ip->i_lock)->mr_lock){----}, at: [<e1126163>]
xfs_ilock+0x4a/0x68 [xfs]
Sep 29 12:18:31 X kernel: 
Sep 29 12:18:31 X kernel: other info that might help us debug this:
Sep 29 12:18:31 X kernel: 4 locks held by kswapd0/157:
Sep 29 12:18:31 X kernel:  #0:  (shrinker_rwsem){----}, at: [<c04504b3>]
shrink_slab+0x25/0x123
Sep 29 12:18:31 X kernel:  #1:  (iprune_mutex){--..}, at: [<c05f9dec>]
mutex_lock+0x21/0x24
Sep 29 12:18:31 X kernel:  #2:  (&(&ip->i_iolock)->mr_lock){----}, at:
[<e1126135>] xfs_ilock+0x1c/0x68 [xfs]
Sep 29 12:18:31 X kernel:  #3:  (&(&ip->i_lock)->mr_lock){----}, at:
[<e1126163>] xfs_ilock+0x4a/0x68 [xfs]
Sep 29 12:18:31 X kernel: 
Sep 29 12:18:31 X kernel: stack backtrace:
Sep 29 12:18:31 X kernel:  [<c0403f8d>] show_trace_log_lvl+0x58/0x16a
Sep 29 12:18:31 X kernel:  [<c0404565>] show_trace+0xd/0x10
Sep 29 12:18:31 X kernel:  [<c0404602>] dump_stack+0x19/0x1b
Sep 29 12:18:31 X kernel:  [<c04310d8>] __lock_acquire+0x75f/0x986
Sep 29 12:18:31 X kernel:  [<c0431870>] lock_acquire+0x4b/0x6b
Sep 29 12:18:31 X kernel:  [<c042e94c>] down_read+0x2d/0x3f
Sep 29 12:18:31 X kernel:  [<e112617c>] xfs_ilock+0x63/0x68 [xfs]
Sep 29 12:18:31 X kernel:  [<e113f19f>] xfs_inactive_free_eofblocks+0x97/0x1fe [xfs]
Sep 29 12:18:31 X kernel:  [<e1143f18>] xfs_inactive+0x171/0x9af [xfs]
Sep 29 12:18:31 X kernel:  [<e114cfdd>] xfs_fs_clear_inode+0x31/0x6d [xfs]
Sep 29 12:18:31 X kernel:  [<c047a5df>] clear_inode+0xd8/0x129
Sep 29 12:18:31 X kernel:  [<c047a8b4>] dispose_list+0x3c/0xc1
Sep 29 12:18:31 X kernel:  [<c047aaac>] shrink_icache_memory+0x173/0x19b
Sep 29 12:18:31 X kernel:  [<c045055e>] shrink_slab+0xd0/0x123
Sep 29 12:18:31 X kernel:  [<c0450896>] kswapd+0x260/0x336
Sep 29 12:18:31 X kernel:  [<c042bf87>] kthread+0xb0/0xdd
Sep 29 12:18:31 X kernel:  [<c0401005>] kernel_thread_helper+0x5/0xb
Sep 29 12:18:31 X kernel: DWARF2 unwinder stuck at kernel_thread_helper+0x5/0xb
Sep 29 12:18:31 X kernel: Leftover inexact backtrace:
Sep 29 12:18:31 X kernel:  [<c0404565>] show_trace+0xd/0x10
Sep 29 12:18:31 X kernel:  [<c0404602>] dump_stack+0x19/0x1b
Sep 29 12:18:31 X kernel:  [<c04310d8>] __lock_acquire+0x75f/0x986
Sep 29 12:18:32 X kernel:  [<c0431870>] lock_acquire+0x4b/0x6b
Sep 29 12:18:32 X kernel:  [<c042e94c>] down_read+0x2d/0x3f
Sep 29 12:18:32 X kernel:  [<e112617c>] xfs_ilock+0x63/0x68 [xfs]
Sep 29 12:18:32 X kernel:  [<e113f19f>] xfs_inactive_free_eofblocks+0x97/0x1fe [xfs]
Sep 29 12:18:32 X kernel:  [<e1143f18>] xfs_inactive+0x171/0x9af [xfs]
Sep 29 12:18:32 X kernel:  [<e114cfdd>] xfs_fs_clear_inode+0x31/0x6d [xfs]
Sep 29 12:18:32 X kernel:  [<c047a5df>] clear_inode+0xd8/0x129
Sep 29 12:18:32 X kernel:  [<c047a8b4>] dispose_list+0x3c/0xc1
Sep 29 12:18:32 X kernel:  [<c047aaac>] shrink_icache_memory+0x173/0x19b
Sep 29 12:18:32 X kernel:  [<c045055e>] shrink_slab+0xd0/0x123
Sep 29 12:18:32 X kernel:  [<c0450896>] kswapd+0x260/0x336
Sep 29 12:18:32 X kernel:  [<c042bf87>] kthread+0xb0/0xdd
Sep 29 12:18:32 X kernel:  [<c0401005>] kernel_thread_helper+0x5/0xb

Version-Release number of selected component (if applicable):
kernel-2.6.18-1.2189.fc5
Comment 1 Eric Sandeen 2006-10-04 00:28:44 EDT
The xfs guys have done some lockdep work, I'll see what they've got so far.

In the meantime, this looks like a false positive.

-Eric
Comment 2 Dave Jones 2006-10-16 20:08:56 EDT
A new kernel update has been released (Version: 2.6.18-1.2200.fc5)
based upon a new upstream kernel release.

Please retest against this new kernel, as a large number of patches
go into each upstream release, possibly including changes that
may address this problem.

This bug has been placed in NEEDINFO state.
Due to the large volume of inactive bugs in bugzilla, if this bug is
still in this state in two weeks time, it will be closed.

Should this bug still be relevant after this period, the reporter
can reopen the bug at any time. Any other users on the Cc: list
of this bug can request that the bug be reopened by adding a
comment to the bug.

In the last few updates, some users upgrading from FC4->FC5
have reported that installing a kernel update has left their
systems unbootable. If you have been affected by this problem
please check you only have one version of device-mapper & lvm2
installed.  See bug 207474 for further details.

If this bug is a problem preventing you from installing the
release this version is filed against, please see bug 169613.

If this bug has been fixed, but you are now experiencing a different
problem, please file a separate bug for the new problem.

Thank you.
Comment 3 Dawid Gajownik 2006-10-22 07:24:59 EDT
Seems to be fixed now, thanks!

Note You need to log in before you can comment on or make changes to this bug.